CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Pin Definitions for Hardware Platform                           PinDefs_AiChip_Latest.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PUB HardwarePlatformName
  return String( "AiChip Latest" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

CON

  USB_PLU       = 18
  USB_MIN       = 19
  USB_ENA       = 23

  TV_ADC0       = 20
  TV_ADC1       = 21
  TV_ADC2       = 22

  SER_RX0       = 24
  SER_TX0       = 25

  KBD_CLK       = 26
  KBD_DAT       = 27

  MOU_CLK       = SER_RX0
  MOU_DAT       = SER_TX0

  LED_RED       = SER_TX0
  LED_GRN       = 30

  AUD_MON       = USB_ENA
    
PUB SetPins

  '       Set oscillator configuration ...
  
  SetPin( pindefs#PACKED_STRING_CLKMODE , _CLKMODE )
  SetPin( pindefs#PACKED_STRING_XINFREQ , _XINFREQ )

  '       This function ...             Is on pin ..
  
  SetPin( pindefs#PACKED_STRING_TV_ADC0 , TV_ADC0  )
  SetPin( pindefs#PACKED_STRING_TV_ADC1 , TV_ADC1  )
  SetPin( pindefs#PACKED_STRING_TV_ADC2 , TV_ADC2  )

  SetPin( pindefs#PACKED_STRING_SER_RX0 , SER_RX0  )
  SetPin( pindefs#PACKED_STRING_SER_TX0 , SER_TX0  )

  SetPin( pindefs#PACKED_STRING_USB_PLU , USB_PLU  )
  SetPin( pindefs#PACKED_STRING_USB_MIN , USB_MIN  )
  SetPin( pindefs#PACKED_STRING_USB_ENA , USB_ENA  )

  SetPin( pindefs#PACKED_STRING_MOU_CLK , MOU_CLK  )
  SetPin( pindefs#PACKED_STRING_MOU_DAT , MOU_DAT  )

  SetPin( pindefs#PACKED_STRING_KBD_CLK , KBD_CLK  )
  SetPin( pindefs#PACKED_STRING_KBD_DAT , KBD_DAT  )
  
  SetPin( pindefs#PACKED_STRING_LED_GRN , LED_GRN  )
  SetPin( pindefs#PACKED_STRING_LED_RED , LED_RED  )
 
  SetPin( pindefs#PACKED_STRING_LED_0   , LED_GRN  )
  SetPin( pindefs#PACKED_STRING_LED_1   , LED_RED  )

  SetPin( pindefs#PACKED_STRING_AUD_MON , AUD_MON  )
  
CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following except for new PinDefs_Library_XXX.spin                  *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  pindefs : "PinDefs_Library_XXX"

PUB Version
  return \pindefs.Version
  
PUB SetPin( packedString, pinNumber )
  \pindefs.setPin( packedString, pinNumber )

PUB GetPinNumber( packedString )
  return \pindefs.GetPinNumber( packedString )

PUB GetSetting( packedString )
  return \pindefs.GetSetting( packedString )
  
PUB GetPinUse( pinNumber )
  return \pindefs.GetPinUse( pinNumber )

PUB Packed( strPtr )
  return \pindefs.Packed( strPtr )
  
PUB Alias
  \pindefs.Alias
  