
CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Pin Definitions for Hardware Platform                          PinDefs_AiChip_Orginal.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PUB HardwarePlatformName
  return String( "AiChip Original" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

CON

  TV_ADC0       = 12
  TV_ADC1       = 13
  TV_ADC2       = 14

  SER_RX0       = 8
  SER_TX0       = 9

  USB_PLU       = 10
  USB_MIN       = 11
  USB_ENA       = 15

  VGA_V         = 16
  VGA_H         = 17
  VGA_B0        = 18
  VGA_B1        = 19
  VGA_G0        = 20
  VGA_G1        = 21
  VGA_R0        = 22
  VGA_R1        = 23
  
  MOU_CLK       = 24
  MOU_DAT       = 25

  KBD_CLK       = 26
  KBD_DAT       = 27

  LED_RED       = SER_TX0
  LED_GRN       = 30

  AUD_MON       = USB_ENA
  AUD_L         = USB_PLU
  AUD_R         = USB_MIN
    
PUB SetPins

  '       Set oscillator configuration ...
  
  SetPin( pindefs#PACKED_STRING_CLKMODE , _CLKMODE )
  SetPin( pindefs#PACKED_STRING_XINFREQ , _XINFREQ )

  '       This function ...             Is on pin ...
  
  SetPin( pindefs#PACKED_STRING_TV_ADC0 , TV_ADC0  )
  SetPin( pindefs#PACKED_STRING_TV_ADC1 , TV_ADC1  )
  SetPin( pindefs#PACKED_STRING_TV_ADC2 , TV_ADC2  )

  SetPin( pindefs#PACKED_STRING_SER_RX0 , SER_RX0  )
  SetPin( pindefs#PACKED_STRING_SER_TX0 , SER_TX0  )

  SetPin( pindefs#PACKED_STRING_USB_PLU , USB_PLU  )
  SetPin( pindefs#PACKED_STRING_USB_MIN , USB_MIN  )
  SetPin( pindefs#PACKED_STRING_USB_ENA , USB_ENA  )

  SetPin( pindefs#PACKED_STRING_VGA_R0  , VGA_R0   )
  SetPin( pindefs#PACKED_STRING_VGA_R1  , VGA_R1   )
  SetPin( pindefs#PACKED_STRING_VGA_G0  , VGA_G0   )
  SetPin( pindefs#PACKED_STRING_VGA_G1  , VGA_G1   )
  SetPin( pindefs#PACKED_STRING_VGA_B0  , VGA_B0   )
  SetPin( pindefs#PACKED_STRING_VGA_B1  , VGA_B1   )
  SetPin( pindefs#PACKED_STRING_VGA_H   , VGA_H    )
  SetPin( pindefs#PACKED_STRING_VGA_V   , VGA_V    )
  
  SetPin( pindefs#PACKED_STRING_MOU_CLK , MOU_CLK  )
  SetPin( pindefs#PACKED_STRING_MOU_DAT , MOU_DAT  )

  SetPin( pindefs#PACKED_STRING_KBD_CLK , KBD_CLK  )
  SetPin( pindefs#PACKED_STRING_KBD_DAT , KBD_DAT  )

  SetPin( pindefs#PACKED_STRING_LED_GRN , LED_GRN  )
  SetPin( pindefs#PACKED_STRING_LED_RED , LED_RED  )
 
  SetPin( pindefs#PACKED_STRING_LED_0   , LED_GRN  )
  SetPin( pindefs#PACKED_STRING_LED_1   , LED_RED  )

  SetPin( pindefs#PACKED_STRING_AUD_MON , AUD_MON  )
  SetPin( pindefs#PACKED_STRING_AUD_L   , AUD_L    )
  SetPin( pindefs#PACKED_STRING_AUD_R   , AUD_R    )
  
CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following except for new PinDefs_Library_XXX.spin                  *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  pindefs : "PinDefs_Library_XXX"

PUB Version
  return \pindefs.Version
  
PUB SetPin( packedString, pinNumber )
  \pindefs.setPin( packedString, pinNumber )

PUB GetPinNumber( packedString )
  return \pindefs.GetPinNumber( packedString )

PUB GetSetting( packedString )
  return \pindefs.GetSetting( packedString )
  
PUB GetPinUse( pinNumber )
  return \pindefs.GetPinUse( pinNumber )

PUB Packed( strPtr )
  return \pindefs.Packed( strPtr )
  
PUB Alias
  \pindefs.Alias
  