CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Pin Definitions for Hardware Platform                                   PinDefs_Hydra.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PUB HardwarePlatformName
  return String( "Hydra" )
  
CON

  _CLKMODE      = XTAL1 + PLL8x
  _XINFREQ      = 10_000_000

CON

  LED_PIN       = 0

  HYD_CLK       = 1
  HYD_DAT       = 2

  NES_CLK       = 3
  NES_SHF       = 4
  NES_AOUT      = 5
  NES_BOUT      = 6

  AUD_MON       = 7

  MOU_CLK       = 8
  MOU_DAT       = 9
  MOU_CKX       = 10
  MOU_DTX       = 11

  KBD_CLK       = 12
  KBD_DAT       = 13
  KBD_CKX       = 14
  KBD_DTX       = 15
 
  VGA_V         = 16
  VGA_H         = 17
  VGA_B0        = 18
  VGA_B1        = 19
  VGA_G0        = 20
  VGA_G1        = 21
  VGA_R0        = 22
  VGA_R1        = 23

  TV_ADC0       = 24
  TV_ADC1       = 25
  TV_ADC2       = 26
  TV_AUD        = 27

  IO_0          = 16
  IO_1          = 17
  IO_2          = 18
  IO_3          = 19
  IO_4          = 20
  IO_5          = 21
  IO_6          = 22
  IO_7          = 23
    
PUB SetPins

  '       Set oscillator configuration ...
  
  SetPin( pindefs#PACKED_STRING_CLKMODE , _CLKMODE )
  SetPin( pindefs#PACKED_STRING_XINFREQ , _XINFREQ )

  '       This function ...             Is on pin ..
  
  SetPin( pindefs#PACKED_STRING_LED_0   , LED_PIN  )

  SetPin( pindefs#PACKED_STRING_HYD_CLK , HYD_CLK  )
  SetPin( pindefs#PACKED_STRING_HYD_DAT , HYD_DAT  )

  SetPin( pindefs#PACKED_STRING_NES_CLK , NES_CLK  )
  SetPin( pindefs#PACKED_STRING_NES_SHF , NES_SHF  )
  SetPin( pindefs#PACKED_STRING_NES_AOU , NES_AOUT )
  SetPin( pindefs#PACKED_STRING_NES_BOU , NES_BOUT )

  SetPin( pindefs#PACKED_STRING_AUD_MON , AUD_MON  )

  SetPin( pindefs#PACKED_STRING_MOU_CLK , MOU_CLK  )
  SetPin( pindefs#PACKED_STRING_MOU_DAT , MOU_DAT  )
  SetPin( pindefs#PACKED_STRING_MOU_CKX , MOU_CKX  )
  SetPin( pindefs#PACKED_STRING_MOU_DTX , MOU_DTX  )

  SetPin( pindefs#PACKED_STRING_KBD_CLK , KBD_CLK  )
  SetPin( pindefs#PACKED_STRING_KBD_DAT , KBD_DAT  )
  SetPin( pindefs#PACKED_STRING_KBD_CKX , KBD_CKX  )
  SetPin( pindefs#PACKED_STRING_KBD_DTX , KBD_DTX  )

  SetPin( pindefs#PACKED_STRING_VGA_R0  , VGA_R0   )
  SetPin( pindefs#PACKED_STRING_VGA_R1  , VGA_R1   )
  SetPin( pindefs#PACKED_STRING_VGA_G0  , VGA_G0   )
  SetPin( pindefs#PACKED_STRING_VGA_G1  , VGA_G1   )
  SetPin( pindefs#PACKED_STRING_VGA_B0  , VGA_B0   )
  SetPin( pindefs#PACKED_STRING_VGA_B1  , VGA_B1   )
  SetPin( pindefs#PACKED_STRING_VGA_H   , VGA_H    )
  SetPin( pindefs#PACKED_STRING_VGA_V   , VGA_V    )

  SetPin( pindefs#PACKED_STRING_TV_ADC0 , TV_ADC0  )
  SetPin( pindefs#PACKED_STRING_TV_ADC1 , TV_ADC1  )
  SetPin( pindefs#PACKED_STRING_TV_ADC2 , TV_ADC2  )
  SetPin( pindefs#PACKED_STRING_TV_AUD  , TV_AUD   )

  SetPin( pindefs#PACKED_STRING_IO_0    , IO_0     )
  SetPin( pindefs#PACKED_STRING_IO_1    , IO_1     )
  SetPin( pindefs#PACKED_STRING_IO_2    , IO_2     )
  SetPin( pindefs#PACKED_STRING_IO_3    , IO_3     )
  SetPin( pindefs#PACKED_STRING_IO_4    , IO_4     )
  SetPin( pindefs#PACKED_STRING_IO_5    , IO_5     )
  SetPin( pindefs#PACKED_STRING_IO_6    , IO_6     )
  SetPin( pindefs#PACKED_STRING_IO_7    , IO_7     )
  
CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following except for new PinDefs_Library_XXX.spin                  *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  pindefs : "PinDefs_Library_XXX"

PUB Version
  return \pindefs.Version
  
PUB SetPin( packedString, pinNumber )
  \pindefs.setPin( packedString, pinNumber )

PUB GetPinNumber( packedString )
  return \pindefs.GetPinNumber( packedString )

PUB GetSetting( packedString )
  return \pindefs.GetSetting( packedString )
  
PUB GetPinUse( pinNumber )
  return \pindefs.GetPinUse( pinNumber )

PUB Packed( strPtr )
  return \pindefs.Packed( strPtr )
  
PUB Alias
  \pindefs.Alias
  