CON

' *******************************************************************************************************
' *                                                                                                     *
' *     Core PinDefs Library code                                         PinDefs_Library_007.spin      *
' *                                                                                                     *
' *******************************************************************************************************

CON

  VERSION_NUMBER         = 007

CON

  ' Any names which aren't assigned a value will be given a numeric value of $8000_0000 upwards. Note
  ' that names defined this way cannot be specified via Packed(String("name")) in the higher level
  ' code.

  #$8000_0000

  ' Oscillator Configuration

  PACKED_STRING_CLKMODE  = $0D8B6BE5                     ' CLKMODE
  PACKED_STRING_XINFREQ  = $612E34B1                     ' XINFREQ

  ' TV

  PACKED_STRING_TV_ADC0  = $52C120D0                     ' TV_ADC0
  PACKED_STRING_TV_ADC1  = $52C120D1                     ' TV_ADC1
  PACKED_STRING_TV_ADC2  = $52C120D2                     ' TV_ADC2
  PACKED_STRING_TV_AUD   = $02960D64                     ' TV_AUD

  ' VGA

  PACKED_STRING_VGA_R0   = $02C70C90                     ' VGA_R0
  PACKED_STRING_VGA_R1   = $02C70C91                     ' VGA_R1
  PACKED_STRING_VGA_G0   = $02C709D0                     ' VGA_G0
  PACKED_STRING_VGA_G1   = $02C709D1                     ' VGA_G1
  PACKED_STRING_VGA_B0   = $02C70890                     ' VGA_B0
  PACKED_STRING_VGA_B1   = $02C70891                     ' VGA_B1
  PACKED_STRING_VGA_H    = $00163868                     ' VGA_H
  PACKED_STRING_VGA_V    = $00163876                     ' VGA_V

  ' Keyboard

  PACKED_STRING_KBD_CLK  = $2C441B2B                     ' KBD_CLK
  PACKED_STRING_KBD_DAT  = $2C442074                     ' KBD_DAT
  PACKED_STRING_KBD_CKX  = $2C441AF8                     ' KBD_CKX
  PACKED_STRING_KBD_DTX  = $2C442538                     ' KBD_DTX

  ' Mouse

  PACKED_STRING_MOU_CLK  = $35F51B2B                     ' MOU_CLK
  PACKED_STRING_MOU_DAT  = $35F52074                     ' MOU_DAT
  PACKED_STRING_MOU_CKX  = $35F51AF8                     ' MOU_CKX
  PACKED_STRING_MOU_DTX  = $35F52538                     ' MOU_DTX

  ' Download Serial Interface

  PACKED_STRING_TX_PROP  = $531093F0                     ' TX_PROP
  PACKED_STRING_RX_PROP  = $4B1093F0                     ' RX_PROP

  ' User Specific Serial Interfaces

  PACKED_STRING_SER_TX0  = $4CB2A610                     ' SER_TX0
  PACKED_STRING_SER_TX1  = $4CB2A611                     ' SER_TX1
  PACKED_STRING_SER_TX2  = $4CB2A612                     ' SER_TX2
  PACKED_STRING_SER_TX3  = $4CB2A613                     ' SER_TX3

  PACKED_STRING_SER_RX0  = $4CB29610                     ' SER_RX0
  PACKED_STRING_SER_RX1  = $4CB29611                     ' SER_RX1
  PACKED_STRING_SER_RX2  = $4CB29612                     ' SER_RX2
  PACKED_STRING_SER_RX3  = $4CB29613                     ' SER_RX3

  PACKED_STRING_SER_CTS0 = $4CB21D10                     ' SER_CTS0
  PACKED_STRING_SER_CTS1 = $4CB21D11                     ' SER_CTS1
  PACKED_STRING_SER_CTS2 = $4CB21D12                     ' SER_CTS2
  PACKED_STRING_SER_CTS3 = $4CB21D13                     ' SER_CTS3

  PACKED_STRING_SER_RTS0 = $4CB29510                     ' SER_RTS0
  PACKED_STRING_SER_RTS1 = $4CB29511                     ' SER_RTS1
  PACKED_STRING_SER_RTS2 = $4CB29512                     ' SER_RTS2
  PACKED_STRING_SER_RTS3 = $4CB29513                     ' SER_RTS3

  PACKED_STRING_SER_ATN0 = $4CB20D10                     ' SER_ATN0
  PACKED_STRING_SER_ATN1 = $4CB20D11                     ' SER_ATN1
  PACKED_STRING_SER_ATN2 = $4CB20D12                     ' SER_ATN2
  PACKED_STRING_SER_ATN3 = $4CB20D13                     ' SER_ATN3

  ' Audio

  PACKED_STRING_AUD_MON  = $06A46BEE                     ' AUD_MON
  PACKED_STRING_AUD_L    = $0001A92C                     ' AUD_L
  PACKED_STRING_AUD_R    = $0001A932                     ' AUD_R

  ' Microphone

  PACKED_STRING_MIC_PLU  = $35238335                     ' MIC_PLU
  PACKED_STRING_MIC_MIN  = $35236A6E                     ' MIC_MIN

  ' USB

  PACKED_STRING_USB_PLU  = $56628335                     ' USB_PLU
  PACKED_STRING_USB_MIN  = $56626A6E                     ' USB_MIN
  PACKED_STRING_USB_ENA  = $56622BA1                     ' USB_ENA

  ' I2C

  PACKED_STRING_I2C_SCL  = $27A398EC                     ' I2C_SCL
  PACKED_STRING_I2C_SDA  = $27A39921                     ' I2C_SDA
  PACKED_STRING_I2C_WP   = $013D1DF0                     ' I2C_WP

  ' SPI

  PACKED_STRING_SPI_DIN  = $4E09226E                     ' SPI_DIN
  PACKED_STRING_SPI_DOUT = $4E0923F4                     ' SPI_DOUT
  PACKED_STRING_SPI_DIO  = $4E09226F                     ' SPI_DIO
  PACKED_STRING_SPI_CLK  = $4E091B2B                     ' SPI_CLK
  PACKED_STRING_SPI_CS   = $027048F3                     ' SPI_CS

  ' Shared I2C and SPI

  PACKED_STRING_SI2_DIO  = $4D3D226F                     ' SI2_DIO
  PACKED_STRING_SI2_CLK  = $4D3D1B2B                     ' SI2_CLK
  PACKED_STRING_SI2_CS   = $0269E8F3                     ' SI2_CS
  PACKED_STRING_SI2_WP   = $0269EDF0                     ' SI2_WP

  ' SD Card

  PACKED_STRING_SD_CLK   = $02641B2B                     ' SD_CLK
  PACKED_STRING_SD_DI    = $00132129                     ' SD_DI
  PACKED_STRING_SD_DO    = $0013212F                     ' SD_DO
  PACKED_STRING_SD_CS    = $001320F3                     ' SD_CS
  PACKED_STRING_SD_IRQ   = $02644CB1                     ' SD_IRQ

  ' Parallel LCD

  PACKED_STRING_LCD_D0   = $01832110                     ' LCD_D0
  PACKED_STRING_LCD_D1   = $01832111                     ' LCD_D1
  PACKED_STRING_LCD_D2   = $01832112                     ' LCD_D2
  PACKED_STRING_LCD_D3   = $01832113                     ' LCD_D3
  PACKED_STRING_LCD_D4   = $01832114                     ' LCD_D4
  PACKED_STRING_LCD_D5   = $01832115                     ' LCD_D5
  PACKED_STRING_LCD_D6   = $01832116                     ' LCD_D6
  PACKED_STRING_LCD_D7   = $01832117                     ' LCD_D7

  PACKED_STRING_LCD_RS   = $018324B3                     ' LCD_RS
  PACKED_STRING_LCD_RS0  = $306494D0                     ' LCD_RS0
  PACKED_STRING_LCD_RS1  = $306494D1                     ' LCD_RS1

  PACKED_STRING_LCD_E    = $000C1925                     ' LCD_E

  PACKED_STRING_LCD_BKL  = $306412EC                     ' LCD_BKL

  ' Coloured LED's

  PACKED_STRING_LED_GRN  = $30A43CAE                     ' LED_GRN
  PACKED_STRING_LED_RED  = $30A49164                     ' LED_RED
  PACKED_STRING_LED_YEL  = $30A4C96C                     ' LED_YEL
  PACKED_STRING_LED_ORG  = $30A47CA7                     ' LED_ORG
  PACKED_STRING_LED_BLU  = $30A41335                     ' LED_BLU
  PACKED_STRING_LED_WHT  = $30A4BA34                     ' LED_WHT

  ' RGB LED

  PACKED_STRING_RGB_R    = $001238B2                     ' RGB_R
  PACKED_STRING_RGB_G    = $001238A7                     ' RGB_G
  PACKED_STRING_RGB_B    = $001238A2                     ' RGB_B

  ' Diagnostic LED's

  PACKED_STRING_LED_0    = $000C2910                     ' LED_0
  PACKED_STRING_LED_1    = $000C2911                     ' LED_1
  PACKED_STRING_LED_2    = $000C2912                     ' LED_2
  PACKED_STRING_LED_3    = $000C2913                     ' LED_3
  PACKED_STRING_LED_4    = $000C2914                     ' LED_4
  PACKED_STRING_LED_5    = $000C2915                     ' LED_5
  PACKED_STRING_LED_6    = $000C2916                     ' LED_6
  PACKED_STRING_LED_7    = $000C2917                     ' LED_7

  PACKED_STRING_LED_8    = $000C2918                     ' LED_8
  PACKED_STRING_LED_9    = $000C2919                     ' LED_9
  PACKED_STRING_LED_10   = $01852710                     ' LED_10
  PACKED_STRING_LED_11   = $01852711                     ' LED_11
  PACKED_STRING_LED_12   = $01852712                     ' LED_12
  PACKED_STRING_LED_13   = $01852713                     ' LED_13
  PACKED_STRING_LED_14   = $01852714                     ' LED_14
  PACKED_STRING_LED_15   = $01852715                     ' LED_15

  ' ENC28J60 Ethernet Controller

  PACKED_STRING_ETH_CS   = $00B440F3                     ' ETH_CS
  PACKED_STRING_ETH_SI   = $00B444E9                     ' ETH_SI
  PACKED_STRING_ETH_SO   = $00B444EF                     ' ETH_SO
  PACKED_STRING_ETH_CLK  = $16881B2B                     ' ETH_CLK
  PACKED_STRING_ETH_IRQ  = $16884CB1                     ' ETH_IRQ

  ' Hydra NET

  PACKED_STRING_HYD_CLK  = $23241B2B                     ' HYD_CLK
  PACKED_STRING_HYD_DAT  = $23242074                     ' HYD_DAT

  ' NES Controller

  PACKED_STRING_NES_CLK  = $38B31B2B                     ' NES_CLK
  PACKED_STRING_NES_SHF  = $38B39A26                     ' NES_SHF
  PACKED_STRING_NES_AOU  = $38B30BF5                     ' NES_AOU
  PACKED_STRING_NES_BOU  = $38B313F5                     ' NES_BOU

  ' I/O Bus

  PACKED_STRING_IO_0     = $00004BD0                     ' IO_0
  PACKED_STRING_IO_1     = $00004BD1                     ' IO_1
  PACKED_STRING_IO_2     = $00004BD2                     ' IO_2
  PACKED_STRING_IO_3     = $00004BD3                     ' IO_3
  PACKED_STRING_IO_4     = $00004BD4                     ' IO_4
  PACKED_STRING_IO_5     = $00004BD5                     ' IO_5
  PACKED_STRING_IO_6     = $00004BD6                     ' IO_6
  PACKED_STRING_IO_7     = $00004BD7                     ' IO_7

  PACKED_STRING_IO_8     = $00004BD8                     ' IO_8
  PACKED_STRING_IO_9     = $00004BD9                     ' IO_9
  PACKED_STRING_IO_10    = $00097F10                     ' IO_10
  PACKED_STRING_IO_11    = $00097F11                     ' IO_11
  PACKED_STRING_IO_12    = $00097F12                     ' IO_12
  PACKED_STRING_IO_13    = $00097F13                     ' IO_13
  PACKED_STRING_IO_14    = $00097F14                     ' IO_14
  PACKED_STRING_IO_15    = $00097F15                     ' IO_15

 ' Address Bus

  PACKED_STRING_BUS_A0   = $00559850                     ' BUS_A0
  PACKED_STRING_BUS_A1   = $00559851                     ' BUS_A1
  PACKED_STRING_BUS_A2   = $00559852                     ' BUS_A2
  PACKED_STRING_BUS_A3   = $00559853                     ' BUS_A3
  PACKED_STRING_BUS_A4   = $00559854                     ' BUS_A4
  PACKED_STRING_BUS_A5   = $00559855                     ' BUS_A5
  PACKED_STRING_BUS_A6   = $00559856                     ' BUS_A6
  PACKED_STRING_BUS_A7   = $00559857                     ' BUS_A7

  PACKED_STRING_BUS_A8   = $00559858                     ' BUS_A8
  PACKED_STRING_BUS_A9   = $00559859                     ' BUS_A9
  PACKED_STRING_BUS_A10  = $0AB30F10                     ' BUS_A10
  PACKED_STRING_BUS_A11  = $0AB30F11                     ' BUS_A11
  PACKED_STRING_BUS_A12  = $0AB30F12                     ' BUS_A12
  PACKED_STRING_BUS_A13  = $0AB30F13                     ' BUS_A13
  PACKED_STRING_BUS_A14  = $0AB30F14                     ' BUS_A14
  PACKED_STRING_BUS_A15  = $0AB30F15                     ' BUS_A15

  PACKED_STRING_BUS_A16  = $0AB30F16                     ' BUS_A16
  PACKED_STRING_BUS_A17  = $0AB30F17                     ' BUS_A17
  PACKED_STRING_BUS_A18  = $0AB30F18                     ' BUS_A18
  PACKED_STRING_BUS_A19  = $0AB30F19                     ' BUS_A19
  PACKED_STRING_BUS_A20  = $0AB30F50                     ' BUS_A20
  PACKED_STRING_BUS_A21  = $0AB30F51                     ' BUS_A21
  PACKED_STRING_BUS_A22  = $0AB30F52                     ' BUS_A22
  PACKED_STRING_BUS_A23  = $0AB30F53                     ' BUS_A23

  ' Data Bus

  PACKED_STRING_BUS_D0   = $00559910                     ' BUS_D0
  PACKED_STRING_BUS_D1   = $00559911                     ' BUS_D1
  PACKED_STRING_BUS_D2   = $00559912                     ' BUS_D2
  PACKED_STRING_BUS_D3   = $00559913                     ' BUS_D3
  PACKED_STRING_BUS_D4   = $00559914                     ' BUS_D4
  PACKED_STRING_BUS_D5   = $00559915                     ' BUS_D5
  PACKED_STRING_BUS_D6   = $00559916                     ' BUS_D6
  PACKED_STRING_BUS_D7   = $00559917                     ' BUS_D7

  PACKED_STRING_BUS_D8   = $00559918                     ' BUS_D8
  PACKED_STRING_BUS_D9   = $00559919                     ' BUS_D9
  PACKED_STRING_BUS_D10  = $0AB32710                     ' BUS_D10
  PACKED_STRING_BUS_D11  = $0AB32711                     ' BUS_D11
  PACKED_STRING_BUS_D12  = $0AB32712                     ' BUS_D12
  PACKED_STRING_BUS_D13  = $0AB32713                     ' BUS_D13
  PACKED_STRING_BUS_D14  = $0AB32714                     ' BUS_D14
  PACKED_STRING_BUS_D15  = $0AB32715                     ' BUS_D15

  PACKED_STRING_BUS_D16  = $0AB32716                     ' BUS_D16
  PACKED_STRING_BUS_D17  = $0AB32717                     ' BUS_D17
  PACKED_STRING_BUS_D18  = $0AB32718                     ' BUS_D18
  PACKED_STRING_BUS_D19  = $0AB32719                     ' BUS_D19
  PACKED_STRING_BUS_D20  = $0AB32750                     ' BUS_D20
  PACKED_STRING_BUS_D21  = $0AB32751                     ' BUS_D21
  PACKED_STRING_BUS_D22  = $0AB32752                     ' BUS_D22
  PACKED_STRING_BUS_D23  = $0AB32753                     ' BUS_D23

  ' UOLED Connections

  PACKED_STRING_OLED_CS  = $3D8520F3                     ' OLED_CS
  PACKED_STRING_OLED_RST = $3D8524B4                     ' OLED_RST
  PACKED_STRING_OLED_DC  = $3D852123                     ' OLED_DC
  PACKED_STRING_OLED_WR  = $3D8525F2                     ' OLED_WR
  PACKED_STRING_OLED_RD  = $3D8524A4                     ' OLED_RD
  PACKED_STRING_OLED_VEN = $3D8525AE                     ' OLED_VEN

  ' Servos

  PACKED_STRING_SRV_0    = $00139590                     ' SRV_0
  PACKED_STRING_SRV_1    = $00139591                     ' SRV_1
  PACKED_STRING_SRV_2    = $00139592                     ' SRV_2
  PACKED_STRING_SRV_3    = $00139593                     ' SRV_3
  PACKED_STRING_SRV_4    = $00139594                     ' SRV_4
  PACKED_STRING_SRV_5    = $00139595                     ' SRV_5
  PACKED_STRING_SRV_6    = $00139596                     ' SRV_6
  PACKED_STRING_SRV_7    = $00139597                     ' SRV_7

  PACKED_STRING_SRV_8    = $00139598                     ' SRV_8
  PACKED_STRING_SRV_9    = $00139599                     ' SRV_9
  PACKED_STRING_SRV_10   = $0272B710                     ' SRV_10
  PACKED_STRING_SRV_11   = $0272B711                     ' SRV_11
  PACKED_STRING_SRV_12   = $0272B712                     ' SRV_12
  PACKED_STRING_SRV_13   = $0272B713                     ' SRV_13
  PACKED_STRING_SRV_14   = $0272B714                     ' SRV_14
  PACKED_STRING_SRV_15   = $0272B715                     ' SRV_15

  ' PWM

  PACKED_STRING_PWM_0    = $0010BB50                     ' PWM_0
  PACKED_STRING_PWM_1    = $0010BB51                     ' PWM_1
  PACKED_STRING_PWM_2    = $0010BB52                     ' PWM_2
  PACKED_STRING_PWM_3    = $0010BB53                     ' PWM_3
  PACKED_STRING_PWM_4    = $0010BB54                     ' PWM_4
  PACKED_STRING_PWM_5    = $0010BB55                     ' PWM_5
  PACKED_STRING_PWM_6    = $0010BB56                     ' PWM_6
  PACKED_STRING_PWM_7    = $0010BB57                     ' PWM_7

  PACKED_STRING_PWM_8    = $0010BB58                     ' PWM_8
  PACKED_STRING_PWM_9    = $0010BB59                     ' PWM_9
  PACKED_STRING_PWM_10   = $02176F10                     ' PWM_10
  PACKED_STRING_PWM_11   = $02176F11                     ' PWM_11
  PACKED_STRING_PWM_12   = $02176F12                     ' PWM_12
  PACKED_STRING_PWM_13   = $02176F13                     ' PWM_13
  PACKED_STRING_PWM_14   = $02176F14                     ' PWM_14
  PACKED_STRING_PWM_15   = $02176F15                     ' PWM_15

  ' Not Connected

  PACKED_STRING_NC       = $000003A3                     ' NC

CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following                                                          *
' *                                                                                                     *
' *******************************************************************************************************

VAR

  byte firstGetPins                                     ' Flag for when pins have been accessed by a get

  long pinUsed                                          ' Pins which have been used by a get access

  long setPtr                                           ' Address after last entry set
      
PUB Version

  abort VERSION_NUMBER

PUB TableStartAddress
  abort $7FFC
  
PUB SetPin( packedString, pinNumber )
  if setPtr == 0
    setPtr := \TableStartAddress
    \SetPin( PACKED_STRING_I2C_SCL , 28 )
    \SetPin( PACKED_STRING_I2C_SDA , 29 )
    \SetPin( PACKED_STRING_TX_PROP , 30 )
    \SetPin( PACKED_STRING_RX_PROP , 31 )
  long[ setPtr ] := packedString
  setPtr -= 4
  long[ setPtr ] := pinNumber
  setPtr -= 4
  long[ setPtr ] := 0
  abort
    
PUB GetPinNumber( packedString ) | pinNumber, pinMask

  if firstGetPins~~ == 0
    SetClkModeAndXinFreq
  if ( result := \GetSetting( packedString ) ) => 0
    pinMask := |< result 
    if pinUsed & pinMask
      abort -1
    pinUsed |= pinMask
  abort
  
PUB GetSetting( packedString ) | ptr
  ptr := \TableStartAddress
  repeat
    case long[ ptr ]
      0            : abort -1
      packedString : abort long[ ptr - 4 ]
    ptr -= 8

PUB GetPinUse( pinNumber ) | ptr
  ptr := \TableStartAddress
  repeat
    if long[ ptr ] == 0
      abort 0
    if long[ ptr + 4 ] == pinNumber
      abort long[ ptr ]
    ptr -= 8

CON

  ALIAS_RESULT_OFFSET    = 15 * 4
  ALIAS_PARAMETER_OFFSET = ALIAS_RESULT_OFFSET - 4

  ALIAS_FROM_OFFSET      = 10 * 4
  ALIAS_TO_OFFSET        = ALIAS_FROM_OFFSET - 4

PUB Alias

  if long[ @result - ALIAS_RESULT_OFFSET ] == 0
     long[ @result - ALIAS_RESULT_OFFSET ] := long[ @result - ALIAS_PARAMETER_OFFSET ]

  if long[ @result - ALIAS_RESULT_OFFSET ] == long[ @result - ALIAS_FROM_OFFSET ]
     long[ @result - ALIAS_RESULT_OFFSET ] := long[ @result - ALIAS_TO_OFFSET   ]

  abort
  
PRI SetClkModeAndXinFreq | infClkMode, setClkMode, setSysFreq, clkIndex, pllMultiplier

  infClkMode := \GetSetting( PACKED_STRING_CLKMODE )

  {
  case infClkMode & constant( RCFAST | RCSLOW | XINPUT | XTAL1 | XTAL2 | XTAL3 )
    RCFAST : setClkMode := %0_0_0_00_000
    RCSLOW : setClkMode := %0_0_0_00_001
    XINPUT : setClkMode := %0_0_0_00_010
    XTAL1  : setClkMode := %0_0_1_01_010
    XTAL2  : setClkMode := %0_0_1_10_010
    XTAL3  : setClkMode := %0_0_1_11_010
  }
  clkIndex := >| ( infClkMode & constant( RCFAST | RCSLOW | XINPUT | XTAL1 | XTAL2 | XTAL3 ) )
  setClkMode := LookUp( clkIndex : %0_0_0_00_000, %0_0_0_00_001, %0_0_0_00_010, %0_0_1_01_010, %0_0_1_10_010, %0_0_1_11_010 )

  setSysFreq := \GetSetting( PACKED_STRING_XINFREQ )

  if ( infClkMode & constant( XINPUT | XTAL1 | XTAL2 | XTAL3 ) ) and ( infClkMode & constant( PLL1x | PLL2x | PLL4x | PLL8x | PLL16x ) )
    {
    setClkMode &= %0_1_1_11_000
    case infClkMode & constant( PLL1x | PLL2x | PLL4x | PLL8x | PLL16x )
      PLL1x  : setClkMode |= %0_1_0_00_011
      PLL2x  : setClkMode |= %0_1_0_00_100
      PLL4x  : setClkMode |= %0_1_0_00_101
      PLL8x  : setClkMode |= %0_1_0_00_110
      PLL16x : setClkMode |= %0_1_0_00_111
    setSysFreq := setSysFreq << ( ( setClkMode & %111 ) - %011 )
    }
    setSysFreq *= ( pllMultiplier := ( infClkMode >> constant( ( >| PLL1x ) - 1 ) ) )
    setClkMode := ( setClkMode & %0_1_1_11_000 ) | ( ( >| pllMultiplier ) + %0_1_0_00_010 )

  if ( CLKMODE & %0_1_1_11_110 ) == 0
    ClkSet( ( setClkMode & %0_1_1_11_000 ) | ( CLKMODE & %0_0_0_00_111 ), CLKFREQ )
    WaitCnt( CLKFREQ / 100 + CNT )

  ClkSet( setClkMode, setSysFreq )

PUB Packed( strPtr ) | ch, chVal, count

  count := 0
  repeat StrSize( strPtr ) - 1
    ch := UcaseByte( strPtr++ )
    if ( chVal := LookDown( ch : "A".."Z", "0".."3" ) )
      if ++count =< 5
        result := ( result << 5 ) | chVal

  abort ( result << 6 ) | ( UcaseByte( strPtr ) - $20 )

PRI UcaseByte( strPtr )

  result := byte[ strPtr ]
  if result => "a" and result =< "z"
    result := result - "a" + "A"
    