CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Pin Definitions for Hardware Platform                                 PinDefs_PropRpm.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PUB HardwarePlatformName
  return String( "PropRpm" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 5_000_000

CON

  TV_ADC0       = 12
  TV_ADC1       = 13
  TV_ADC2       = 14
  TV_AUD        = 15
  
  LED_0         = 16
  LED_1         = 17
  LED_2         = 18
  LED_3         = 19
  LED_4         = 20
  LED_5         = 21
  LED_6         = 22
  LED_7         = 23
  LED_8         = 24
  LED_9         = 25
  
PUB SetPins

  '       Set oscillator configuration ...
  
  SetPin( pindefs#PACKED_STRING_CLKMODE , _CLKMODE )
  SetPin( pindefs#PACKED_STRING_XINFREQ , _XINFREQ )

  '       This function ...             Is on pin ..
  
  SetPin( pindefs#PACKED_STRING_TV_ADC0 , TV_ADC0  )
  SetPin( pindefs#PACKED_STRING_TV_ADC1 , TV_ADC1  )
  SetPin( pindefs#PACKED_STRING_TV_ADC2 , TV_ADC2  )
  SetPin( pindefs#PACKED_STRING_TV_AUD  , TV_AUD   )
  
  SetPin( pindefs#PACKED_STRING_LED_0   , LED_0    )
  SetPin( pindefs#PACKED_STRING_LED_1   , LED_1    )
  SetPin( pindefs#PACKED_STRING_LED_2   , LED_2    )
  SetPin( pindefs#PACKED_STRING_LED_3   , LED_3    )
  SetPin( pindefs#PACKED_STRING_LED_4   , LED_4    )
  SetPin( pindefs#PACKED_STRING_LED_5   , LED_5    )
  SetPin( pindefs#PACKED_STRING_LED_6   , LED_6    )
  SetPin( pindefs#PACKED_STRING_LED_7   , LED_7    )
  SetPin( pindefs#PACKED_STRING_LED_8   , LED_8    )
  SetPin( pindefs#PACKED_STRING_LED_9   , LED_9    )

CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following except for new PinDefs_Library_XXX.spin                  *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  pindefs : "PinDefs_Library_XXX"

PUB Version
  return \pindefs.Version
  
PUB SetPin( packedString, pinNumber )
  \pindefs.setPin( packedString, pinNumber )

PUB GetPinNumber( packedString )
  return \pindefs.GetPinNumber( packedString )

PUB GetSetting( packedString )
  return \pindefs.GetSetting( packedString )
  
PUB GetPinUse( pinNumber )
  return \pindefs.GetPinUse( pinNumber )

PUB Packed( strPtr )
  return \pindefs.Packed( strPtr )
  
PUB Alias
  \pindefs.Alias
  