CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Pin Definitions for Hardware Platform                         PinDefs_ProtoBoard_5MHz.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PUB HardwarePlatformName
  return String( "ProtoBoard 5MHz" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 5_000_000

CON

  VGA_V         = 16
  VGA_H         = 17
  VGA_B0        = 18
  VGA_B1        = 19
  VGA_G0        = 20
  VGA_G1        = 21
  VGA_R0        = 22
  VGA_R1        = 23
  
  MOU_CLK       = 24
  MOU_DAT       = 25

  KBD_CLK       = 26
  KBD_DAT       = 27

PUB SetPins

  '       Set oscillator configuration ...
  
  SetPin( pindefs#PACKED_STRING_CLKMODE , _CLKMODE )
  SetPin( pindefs#PACKED_STRING_XINFREQ , _XINFREQ )

  '       This function ...             Is on pin ..
  
  SetPin( pindefs#PACKED_STRING_VGA_R0  , VGA_R0   )
  SetPin( pindefs#PACKED_STRING_VGA_R1  , VGA_R1   )
  SetPin( pindefs#PACKED_STRING_VGA_G0  , VGA_G0   )
  SetPin( pindefs#PACKED_STRING_VGA_G1  , VGA_G1   )
  SetPin( pindefs#PACKED_STRING_VGA_B0  , VGA_B0   )
  SetPin( pindefs#PACKED_STRING_VGA_B1  , VGA_B1   )
  SetPin( pindefs#PACKED_STRING_VGA_H   , VGA_H    )
  SetPin( pindefs#PACKED_STRING_VGA_V   , VGA_V    )
  
  SetPin( pindefs#PACKED_STRING_MOU_CLK , MOU_CLK  )
  SetPin( pindefs#PACKED_STRING_MOU_DAT , MOU_DAT  )

  SetPin( pindefs#PACKED_STRING_KBD_CLK , KBD_CLK  )
  SetPin( pindefs#PACKED_STRING_KBD_DAT , KBD_DAT  )
  
CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following except for new PinDefs_Library_XXX.spin                  *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  pindefs : "PinDefs_Library_XXX"

PUB Version
  return \pindefs.Version
  
PUB SetPin( packedString, pinNumber )
  \pindefs.setPin( packedString, pinNumber )

PUB GetPinNumber( packedString )
  return \pindefs.GetPinNumber( packedString )

PUB GetSetting( packedString )
  return \pindefs.GetSetting( packedString )
  
PUB GetPinUse( pinNumber )
  return \pindefs.GetPinUse( pinNumber )

PUB Packed( strPtr )
  return \pindefs.Packed( strPtr )
  
PUB Alias
  \pindefs.Alias
  