CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Pin Definitions for Hardware Platform                               PinDefs_SpinStamp.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PUB HardwarePlatformName
  return String( "SpinStamp" )
  
CON

  _CLKMODE      = XTAL1 + PLL8x
  _XINFREQ      = 10_000_000

CON

  SO_PIN        = 16
  SI_PIN        = 17
  ATN_PIN       = 18
    
PUB SetPins | pinNumber

  '       Set oscillator configuration ...
  
  SetPin( pindefs#PACKED_STRING_CLKMODE  , _CLKMODE )
  SetPin( pindefs#PACKED_STRING_XINFREQ  , _XINFREQ )

  '       This function ...              Is on pin ..
  
  SetPin( pindefs#PACKED_STRING_SER_TX0  , SO_PIN  )
  SetPin( pindefs#PACKED_STRING_SER_RX0  , SI_PIN  )
  SetPin( pindefs#PACKED_STRING_SER_ATN0 , ATN_PIN )

  repeat pinNumber from 19 to 27
    SetPin( pindefs#PACKED_STRING_NC     , pinNumber )

CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following except for new PinDefs_Library_XXX.spin                  *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  pindefs : "PinDefs_Library_XXX"

PUB Version
  return \pindefs.Version
  
PUB SetPin( packedString, pinNumber )
  \pindefs.setPin( packedString, pinNumber )

PUB GetPinNumber( packedString )
  return \pindefs.GetPinNumber( packedString )

PUB GetSetting( packedString )
  return \pindefs.GetSetting( packedString )
  
PUB GetPinUse( pinNumber )
  return \pindefs.GetPinUse( pinNumber )

PUB Packed( strPtr )
  return \pindefs.Packed( strPtr )
  
PUB Alias
  \pindefs.Alias
  