
CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Pin Definitions for Hardware Platform                    PinDefs_Uoled_96_Prop_PLL16x.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PUB HardwarePlatformName
  return String( "Uoled-96-Prop PLL16x" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 8_000_000

CON

  OLED_CS       = 8
  OLED_RST      = 9
  OLED_DC       = 10
  OLED_WR       = 11
  OLED_RD       = 12
  OLED_VEN      = 13

    
PUB SetPins

  '       Set oscillator configuration ...
  
  SetPin( pindefs#PACKED_STRING_CLKMODE  , _CLKMODE )
  SetPin( pindefs#PACKED_STRING_XINFREQ  , _XINFREQ )

  '       This function ...              Is on pin ..
  
  SetPin( pindefs#PACKED_STRING_OLED_CS  , OLED_CS  )
  SetPin( pindefs#PACKED_STRING_OLED_RST , OLED_RST )
  SetPin( pindefs#PACKED_STRING_OLED_DC  , OLED_DC  )
  SetPin( pindefs#PACKED_STRING_OLED_WR  , OLED_WR  )
  SetPin( pindefs#PACKED_STRING_OLED_RD  , OLED_RD  )
  SetPin( pindefs#PACKED_STRING_OLED_VEN , OLED_VEN )
  
CON

' *******************************************************************************************************
' *                                                                                                     *
' *     No need to update any of the following except for new PinDefs_Library_XXX.spin                  *
' *                                                                                                     *
' *******************************************************************************************************

OBJ

  pindefs : "PinDefs_Library_XXX"

PUB Version
  return \pindefs.Version
  
PUB SetPin( packedString, pinNumber )
  \pindefs.setPin( packedString, pinNumber )

PUB GetPinNumber( packedString )
  return \pindefs.GetPinNumber( packedString )

PUB GetSetting( packedString )
  return \pindefs.GetSetting( packedString )
  
PUB GetPinUse( pinNumber )
  return \pindefs.GetPinUse( pinNumber )

PUB Packed( strPtr )
  return \pindefs.Packed( strPtr )
  
PUB Alias
  \pindefs.Alias
  