CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     Proof of Concept for PinDefs                                         PinDefs_Demo_007.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PRI Version

  result := String( "PinDefs_Demo_007" )

OBJ

' .-----------------------------------------------------------------------------------------------------.
' | Select one of the following or change to match your own hardware                                    |
' `-----------------------------------------------------------------------------------------------------'
  
' pindefs : "PinDefs_DemoBoard_5MHz"                                             
' pindefs : "PinDefs_DemoBoard_6MHz"                                             

' pindefs : "PinDefs_ProtoBoard_5MHz"                                           
' pindefs : "PinDefs_ProtoBoard_6MHz"                                            

' pindefs : "PinDefs_SpinStamp"                                    
' pindefs : "PinDefs_PropRpm"                                    
' pindefs : "PinDefs_Hydra"
' pindefs : "PinDefs_Uoled_96_Prop_PLL8x"                                    
' pindefs : "PinDefs_Uoled_96_Prop_PLL16x"                                    
  
  pindefs : "PinDefs_AiChip_Original"                                     
' pindefs : "PinDefs_AiChip_Latest"                                    

OBJ

' .-----------------------------------------------------------------------------------------------------.
' | This section can be deleted - It's only here to get files put into the .Zip archive for release     |
' `-----------------------------------------------------------------------------------------------------'

  xxdef01 : "PinDefs_DemoBoard_5MHz"                                             
  xxdef02 : "PinDefs_DemoBoard_6MHz"                                             
  xxdef03 : "PinDefs_ProtoBoard_5MHz"                                           
  xxdef04 : "PinDefs_ProtoBoard_6MHz"                                            
  xxdef05 : "PinDefs_SpinStamp"                                    
  xxdef06 : "PinDefs_PropRpm"                                    
  xxdef07 : "PinDefs_Hydra"
  xxdef08 : "PinDefs_Uoled_96_Prop_PLL8x"                                    
  xxdef09 : "PinDefs_Uoled_96_Prop_PLL16x"                                    
  xxdef10 : "PinDefs_AiChip_Original"                                     
  xxdef11 : "PinDefs_AiChip_Latest"        

OBJ
  
  tv      : "TV_Text"

VAR

  long tvPin
  long serPin
  long ledPin
  long audPin
  
  byte pinName[ 10 ] 

  long serStack[50]
  long ledStack[50]
  long audStack[50]
    
PUB Main | i

  pindefs.SetPins

  ' Find which Pin the TV is connected to
  
  tvPin  :=   GetPinNumber( MyPinName(Packed(String( "TV_PIN"  ))) )                      

  ' Try and find a serial output. If we have a dedicated serial output we use that otherwise we fall
  ' back to sending back through the propPlug
  
  serPin :=   GetPinNumber( MyPinName(Packed(String( "SO_PIN" ))) )                        
  if serPin < 0
    serPin := GetPinNumber( MyPinName(Packed(String( "TX_PIN" ))) )                        

  ' Find a LED to flash. We'd prefer a Green LED but failing that RED will do, and failing that we'll
  ' take the first LED which comes along

  ledPin :=   GetPinNumber( MyPinName(Packed(String( "LED_GRN" ))) )                        
  if ledPin < 0
    ledPin := GetPinNumber( MyPinName(Packed(String( "LED_RED" ))) )                        
  if ledPin < 0
    ledPin := GetPinNumber( MyPinName(Packed(String( "LED_PIN" ))) )                        

  ' Find an audio output. We'll start by looking for a mono output, then try and find a left or right

  audPin :=   GetPinNumber( MyPinName(Packed(String( "AUD_MON" ))) )                        
  if audPin < 0
    audPin := GetPinNumber( MyPinName(Packed(String( "AUD_L"   ))) )                        
  if audPin < 0
    audPin := GetPinNumber( MyPinName(Packed(String( "AUD_R"   ))) )                        
   
  if tvPin => 0
    tv.Start( tvPin )
    tv.Str( Version )
    tv.Str( String( " (" ) )
    i := pindefs.Version
    if i < 100
      tv.Out( "0" )
    if i < 10
      tv.Out( "0" )
    tv.Dec( i )
    tv.Str( String( ") " ) )
    StrMax( pindefs.HardwarePlatformName, 16 )
    tv.Out( $0D )

    repeat i from 0 to 10
      ShowPinName( 1,  i    )
      ShowPinName( 14, i+11 )
      ShowPinName( 27, i+22 )
      tv.Out( $0D )

    i := String("TV_PIN")
    tv.Str( i )
    tv.Out( " " )
    i := Packed(i)
    tv.Str( Unpack(i) )
    tv.Out( " " )
    i := MyPinName(i)
    tv.Hex( i, 8 )
    tv.Out( " " )
    tv.Str( Unpack(i) )

    CogNew( Task_Led, @ledStack )
    CogNew( Task_Aud, @audStack )

    repeat
      repeat i from 0 to 3
        tv.Out( $0A )
        tv.out( 30 )
        tv.Out( LookupZ( i : "-\|/" ) )
        tv.Out( " " )
        tv.Out( LookupZ( i : "-/|\" ) )
        WaitCnt( CLKFREQ / 1000 * 150 + CNT )

PRI Task_Ser

  if serPin => 0
    DIRA[ serPin ] := 1
    repeat
      Pause_Ms( 1000 )
    
PRI Task_Led

  if ledPin => 0
    DIRA[ ledPin ] := 1
    repeat
      ! OUTA[ ledPin ]
      Pause_Ms( 500 )

PRI Task_Aud

  if audPin
    repeat
      Pause_Ms( 250 )

      Pause_Ms( 750 )

PRI Pause_Ms( mS )

  WaitCnt( CLKFREQ / 1000 * mS + CNT )
              
PRI ShowPinName( column, pinNumber )
  if pinNumber =< 31
    tv.Out( $0A )
    tv.Out( column-1 )
    tv.Dec( pinNumber )
    if pinNumber < 10
      tv.Out( " " )
    tv.Out( " " )
    tv.Str( GetPinName(pinNumber) )

PRI StrMax( strPtr, width )

  repeat StrSize( strPtr ) <# width
    tv.Out( byte[ strPtr++ ] )
    
PRI GetPinName( pinNumber )
  return Unpack( GetPinUse(pinNumber) )

PRI Unpack( packedString ) | strPtr, chVal
  result := strPtr := @pinName
  if packedString

    if packedString & $8000_0000
      byte[ strPtr++ ] := "$"
      repeat 8
        byte[ strPtr++ ] := UnpackToHex( packedString >> 28 )
        packedString := packedString << 4
    else
      repeat 5
        if ( chVal := LookUpZ( packedString >> 26 : 0, "A".."Z", "0".."3", "?" ) )
          byte[ strPtr++ ] := chVal
        packedString := ( packedString << 6 ) >> 1
      if ( packedString >>= 25 )
        byte[ strPtr++ ] := packedString + $20

  else
    byte[ strPtr++ ] := "-"
    
  byte[ strPtr   ] := 0

PRI UnpackToHex( n )
  result := ( n & $F ) + "0"
  if result > "9"
    result += 7
    
CON

' .-----------------------------------------------------------------------------------------------------.
' | Interface with pindefs routines                                                                     |
' `-----------------------------------------------------------------------------------------------------'

PRI MyPinName( packedString )

  ' This converts the pin names I want to use into pin names which the Propeller Community has chosen
  ' as standard. Do not add any extra parameters or local variables because the call to Alias() relies
  ' on a specific stack configuration when called. If wanting to remove the Alias() calls either remove
  ' this MyPinName() method and use only standard names, or delete all Alias() calls and replace with a
  ' "result := packedString" or "return packedString".

  Alias( Packed(String( "TV_PIN"  )) , Packed(String( "TV_ADC0" )) )
  Alias( Packed(String( "LED_PIN" )) , Packed(String( "LED_0"   )) )
  Alias( Packed(String( "SO_PIN"  )) , Packed(String( "SER_TX0" )) )
  Alias( Packed(String( "SI_PIN"  )) , Packed(String( "SER_RX0" )) )
  Alias( Packed(String( "TX_PIN"  )) , Packed(String( "TX_PROP" )) )
  Alias( Packed(String( "RX_PIN"  )) , Packed(String( "RX_PROP" )) )

' Do not change any of the calls below. Some may look odd, not explicitly returning results when they 
' would be expected to or passing incoming parameters on but this is because there is trickery going
' on elsewhere utilising direct stack access. Any changes here will totally mess that up.
 
PRI Alias( packedStringFrom, packedStringTo )
  pindefs.Alias

PRI GetPinNumber( packedString )
  return pindefs.GetPinNumber( packedString )

PRI GetSetting( packedString )
  return pindefs.GetSetting( packedString )

PRI GetPinUse( pinNumber )
  return pindefs.GetPinUse( pinNumber )

PRI Packed( strPtr )
  return pindefs.Packed( strPtr )
  